# CompSci 107
# Class which defines an iterator for a linked list

class ListIterator:	
	def __init__( self, head_of_list):
		self.current_node = head_of_list
				
	def __iter__(self): 
		return self

	#The __next__() method is called whenever  
	#a value is retrieved from the iterator.
	def __next__( self ):
		if self.current_node != None:
			item = self.current_node.get_data()
			self.current_node = self.current_node.get_next()
			return item
		else :
			raise StopIteration
