# CompSci 107
# Tests the singly linked list implementation of the UnorderedList ADT

from OrderedSLList import OrderedList

def get_ex03_SLlist():
	list_of_nums = [449, 70, 168, 124, 279, 392, 367, 87, 491, 52, 294, 463, 387, 87, 470, 372, 119, 65, 24, 216, 393, 263, \
	160, 159, 490, 53, 225, 69, 395, 161, 86, 133, 214, 454, 120, 135, 298, 177, 300, 58, 168, 493, 332, 469, 394, 308, 301, 91, \
	472, 435, 260, 118, 244, 20, 441, 171, 408, 13, 297, 469, 95, 34, 431, 441, 379, 157, 210, 459, 459, 166, 297, 92, 308, 437, 288, \
	353, 143, 292, 92, 300, 65, 45, 303, 70, 86, 168, 81, 400, 330, 374, 114, 131, 90, 36, 51, 395, 212, 61, 450, 319, 323, 33, 74, 463, \
	349, 480, 213, 23, 421, 163, 134, 108, 196, 425, 171, 129, 86, 49, 351, 125, 353, 70, 236, 454, 92, 325, 30, 298, 497, 334, 188, 353, \
	388, 470, 363, 400, 10, 48, 99, 118, 493, 84, 41, 436, 219, 453, 62, 245, 42, 237, 97, 461, 265, 249, 392, 434, 460, 28, 277, 143, 49, \
	321, 241, 367, 372, 118, 483, 452, 237, 338, 434, 182, 385, 122, 409, 380, 128, 317, 193, 213, 345, 256, 336, 164, 232, 172, 402, \
	291, 449, 191, 161, 322, 353, 407, 478, 67, 318, 71, 424, 28]
	sllist_of_nums = OrderedList()
	for num in list_of_nums:
		sllist_of_nums.add(num)
	return sllist_of_nums

def test_ex03_bigger_SLlist():
	sllist_of_nums = get_ex03_SLlist()
	number = 1
	print(str(number) + ".", sllist_of_nums.get(0), sllist_of_nums.get(15), sllist_of_nums.get(77), sllist_of_nums.get(169), sllist_of_nums.get(sllist_of_nums.size() - 2), sllist_of_nums.get(sllist_of_nums.size() - 1))
	number += 1
	print(str(number) + ".", sllist_of_nums.get_tail())
	number += 1
	sllist_of_nums.add(562)
	print(str(number) + ".", sllist_of_nums.get_tail())
	number += 1
	for i in range(15):
		sllist_of_nums.pop(24)
		sllist_of_nums.pop()
	print(str(number) + ".", sllist_of_nums.pop(54))
	number += 1
	print(str(number) + ".", sllist_of_nums.get_tail())
	number += 1
	if 491 in sllist_of_nums:
		pos = sllist_of_nums.search(491)
		sllist_of_nums.pop(pos)
	print(str(number) + ".", sllist_of_nums.search(237), sllist_of_nums.search(491))
	number += 1
	print(str(number) + ".", sllist_of_nums.size())
	number += 1
	for i in range(15):
		sllist_of_nums.pop(0)
	print(str(number) + ".", sllist_of_nums.get(0))

def test_ex03_small_SLlist():
	sllist_of_nums = OrderedList()
	for num in list(range(40, 9, -3)):
		sllist_of_nums.add(num)
	number = 1
	print(str(number) + ".", "Currently list is:", sllist_of_nums)
	number += 1
	print(str(number) + ".", sllist_of_nums.get(0), sllist_of_nums.get(1), sllist_of_nums.get(8), sllist_of_nums.get(9))
	number += 1
	print(str(number) + ".", sllist_of_nums.get_tail())
	number += 1
	sllist_of_nums.add(45)
	print(str(number) + ".", sllist_of_nums.get_tail())
	number += 1
	print(str(number) + ".", "Currently list is:", sllist_of_nums)
	number += 1
	for i in range(2):
		sllist_of_nums.pop(0)
		sllist_of_nums.pop()
		sllist_of_nums.pop(3)		
	print(str(number) + ".", "Currently list is:", sllist_of_nums)
	number += 1
	print(str(number) + ".", sllist_of_nums.pop(1))
	number += 1
	print(str(number) + ".", "Currently list is:", sllist_of_nums)
	number += 1
	if 25 in sllist_of_nums:
		print(str(number) + ". 25 is in the ordered linked list")
		number += 1
	print(str(number) + ".", sllist_of_nums.search(16), sllist_of_nums.search(31), sllist_of_nums.search(3), sllist_of_nums.search(37))
	number += 1
	print(str(number) + ".", sllist_of_nums.size())
	number += 1

	for i in range(2, 4):
		sllist_of_nums.add(sllist_of_nums.pop(i) + 2)
		print(str(number) + ".", "Currently list is:", sllist_of_nums)
		number += 1
	s = "["
	for i in sllist_of_nums:
		s += str(i) + " "
	s = s.strip() + "]"
	print(str(number) + ".", s)
			
def main():
	print("small ordered list")
	test_ex03_small_SLlist()
	print()
	print("bigger ordered list")
	test_ex03_bigger_SLlist()

main()

'''
small ordered list
1. Currently list is: [10, 13, 16, 19, 22, 25, 28, 31, 34, 37, 40]
2. 10 13 34 37
3. 40
4. 45
5. Currently list is: [10, 13, 16, 19, 22, 25, 28, 31, 34, 37, 40, 45]
6. Currently list is: [16, 19, 25, 31, 34, 37]
7. 19
8. Currently list is: [16, 25, 31, 34, 37]
9. 25 is in the ordered linked list
10. True True False True
11. 5
12. Currently list is: [16, 25, 33, 34, 37]
13. Currently list is: [16, 25, 33, 36, 37]
14. [16 25 33 36 37]


bigger ordered list
1. 10 49 171 435 493 497
2. 497
3. 562
4. 161
5. 463
6. True False
7. 170
8. 49
'''
